<template>
    <div class="flex-container">
        <!-- 查询区域 -->
        <div class="table-page-search-wrapper">
            <!-- 搜索区域 -->
            <a-form layout="inline">
                <a-row :gutter="24">
                    <a-col :md="4" :sm="12">
                        <a-form-item  label="姓名">
                            <a-input  placeholder="姓名" v-model="queryParam.name"></a-input>
                        </a-form-item>
                    </a-col>
                    <a-col :md="4" :sm="12">
                        <a-form-item  label="县分">
                            <a-input  placeholder="县分" v-model="queryParam.substName"></a-input>
                        </a-form-item>
                    </a-col>
                    <a-col :md="4" :sm="12">
                        <a-form-item  label="学校">
                            <a-input  placeholder="学校" v-model="queryParam.schoolName"></a-input>
                        </a-form-item>
                    </a-col>
                    <span class="table-page-search-submitButtons" style="float: left; overflow: hidden;">
                        <a-col :md="6" :sm="24">
                            <a-button @click="search()" type="primary">查询1</a-button>
                            <a-button @click="openAllocation()" style="margin-left: 8px" icon="plus" type="primary">新增</a-button>
                        </a-col>
                    </span>
                </a-row>
            </a-form>

            <!--列表-->
            <s-table :columns="columns" :data="rowdata" bordered ref="table" size="small" class="flex-filling"  :locale="emptyText">
                <template slot="operation" slot-scope="text, record">
                    <a-divider type="vertical"/>
                        <a-popconfirm title="是否要删除此行？" @confirm="deleteAllocation(record.id)">
                            <a>删除</a>
                        </a-popconfirm>
                    <a-divider type="vertical"/>
                </template>
            </s-table>

            <!--编辑----弹框-->
            <a-modal :title="titleName" :visible="modifyvisible"  @ok="createfunctionOk" @cancel="createfunctionCancel" html-type="submit" width="720px">
                <a-form :form="Formtable">

                    <a-form-item :labelCol="{span: 6}" :wrapperCol="{span: 8, offset: 1}" label="账号">
                        <a-input placeholder="账号" v-decorator="[ 'account', {rules: [{ required: true, message: '账号不能为空！' ,whitespace:true}]} ]"></a-input>
                    </a-form-item>

                    <a-form-item :labelCol="{span: 6}"  :wrapperCol="{span: 8, offset: 1}"  label="县分">
                        <a-select placeholder="请选择" @change="changeSubst()" v-model="modifyForm.subName" >
                            <a-select-option key="">请选择</a-select-option>
                            <a-select-option v-for="data in subNameList" :value="data">
                                {{ data}}
                            </a-select-option>
                        </a-select>
                    </a-form-item>

                    <a-form-item :labelCol="{span: 6}" :wrapperCol="{span: 8, offset: 1}"  label="学校名称">
                        <a-select placeholder="请选择" v-model="modifyForm.schoolId">
                            <a-select-option key="">请选择</a-select-option>
                            <a-select-option v-for="data in schoolList"  :value="data.id">
                                {{ data.school_name}}
                            </a-select-option>
                        </a-select>
                    </a-form-item>

                </a-form>
            </a-modal>
        </div>
    </div>
</template>

<script>
    import STable from '@/components/table';
    import {
        getList,addAllocation,
        deleteAllocation,getSubstList,getSchoolList
    } from "@/api/school-center/schoolAllocationAPI"
    import {cloneObject} from '@/utils/util'
    import treecheck from '@/components/sysmanage/treeCheck'
    import treeList from '@/components/sysmanage/treeList'

    export default {
        name: "schoolAllocation",
        components: {
            STable,
            treeList,
            treecheck,
        },
        data: function () {
            return {
                emptyText: {emptyText: '暂无数据'},
                Formtable: this.$form.createForm(this, {name: 'Formtable'}),
                queryParam: {
                    account: '',
                    name: '',
                    substName:'',
                    schoolName:''
                },
                titleName: '',
                modifyvisible:false,
                modifyForm: {
                    id: '',
                    account: '',
                    schoolId: '',
                },
                autoCompleteResult:[],
                subNameList: [],
                schoolList:[],
                addSubName:'',
                columns: [
                    {dataIndex: 'name', width: 100, title: '姓名 ', align: "center"},
                    {dataIndex: 'account', width: 100, title: '账号', align: "center"},
                    {dataIndex: 'substName', width: 100, title: '管辖学校所属县分 ', align: "center"},
                    {dataIndex: 'schoolName', width: 200, title: '管辖学校 ', align: "center"},
                    {
                        dataIndex: 'operation',
                        width: 100,
                        title: '操作',
                        align: "center",
                        scopedSlots: {customRender: 'operation'},
                        fixed: "right"
                    }]
                ,
                rowdata: parameter => {
                    let params = {
                        pageNo: parameter.pageNo,
                        pageSize: parameter.pageSize
                    }

                    //表示
                    let obj = cloneObject(this.queryParam)
                    this.subNameList = [];
                    // 获取县分下拉清单
                    getSubstList(Object.assign(params,obj)).then(res => {
                        if (res.state == 'success') {
                            res.data.forEach((key)=>{
                                this.subNameList.push(key.sub_name)
                            })
                        }
                    })

                    return getList(Object.assign(params,obj)).then(res => {
                        let data = {}
                        if (res.state !== 'success') {
                            this.$message.error("查询失败！", 5);
                            this.emptyText.emptyText = '查询失败！'
                            data = {
                                data: [],
                                pageSize: parameter.pageSize,
                                pageNo: 1,
                                totalCount: 0
                            }
                        } else {
                            data = {
                                data: res.data.records,
                                pageSize: parameter.pageSize,
                                pageNo: parameter.pageNo,
                                totalCount: res.data.total
                            }
                        }
                        return data
                    })
                },
                keyRecord: '',
                recordId: '',
                addUser: false,
            }
        },
        methods:{
            onLoad(){
                let params = [];
                params.substName = "";
                // 获取县分下拉清单
                getSubstList(params).then(res => {
                    if (res.state == 'success') {
                        res.data.forEach((key)=>{
                            this.subNameList.push(key.sub_name)
                        })
                    }
                })
            },
            search() {
                this.$refs.table.refresh({search: true})
            },
            openAllocation() {
                this.titleName = "添加学校2323分配";
                this.modifyvisible = true;
            },
            //提交表单
            createfunctionOk(){
                this.Formtable.validateFields(["account"], {force: true}, (err, values)=>{
                    if (!err){
                        this.modifyForm.account=values.account

                        addAllocation(this.modifyForm).then(res=>{
                            if (res.state=="success") {
                                this.$message.success(res.data ? res.data : '添加成功！', 5);
                                this.search();
                                this.modifyvisible = false;
                                return null;
                            }
                            this.$message.error(res.data ? res.data : '添加失败！', 5);
                        })
                    }
                })
            },
            createfunctionCancel(){
                this.modifyvisible=false
                this.autoCompleteResult=[]
                this.Formtable.setFieldsValue({
                    account: ''
                })

                this.addForm.subName = '';
            },
            deleteAllocation(id){
                let params = {};
                params.id = id;
                deleteAllocation(params).then(res=>{
                    if (res.state=="success") {
                        this.$message.success(res.data ? res.data : '删除成功！', 5);
                        this.search();
                        this.modifyvisible = false;
                        return null;
                    }
                    this.$message.error(res.data ? res.data : '删除失败！', 5);
                })
            },
            changeSubst(){
                let schoolParams = {};
                schoolParams.substName = this.modifyForm.subName;
                this.schoolList = [];

                getSchoolList(schoolParams).then(res => {
                    if (res.state == 'success') {
                        res.data.forEach((key) => {
                            this.schoolList.push(key)
                        })
                    }
                })
            },
            changeSchool(schoolId){
                let schoolParams = {};
                schoolParams.substName = this.modifyForm.subName;
                this.schoolList = [];

                getSchoolList(schoolParams).then(res => {
                    if (res.state == 'success') {
                        res.data.forEach((key) => {
                            this.schoolList.push(key)
                        })

                        this.modifyForm.schoolId = schoolId;
                    }
                })
            },

        }
    }
</script>

<style scoped>

</style>